<?php
/**************************************************
  Coppermine 1.5.x Plugin - gmc_test
**************************************************/

/* Configuration variables
      'plugin_gmc_test_adminmode'
      'plugin_gmc_test_menu_doc'
      'plugin_gmc_test_menu_minicms'
*/

// create Inspekt supercage
$superCage = Inspekt::makeSuperCage();

// Make sure that this file can't be accessed directly, but only from within the Coppermine user interface
if (!defined('IN_COPPERMINE')) {
    die('Not in Coppermine...');
}

if (!GALLERY_ADMIN_MODE) {
    cpg_die(ERROR, $lang_errors['access_denied'], __FILE__, __LINE__);
}

include_once('functions.php');                                                  // include plugin subfunctions


// ** GMC following code from the plugin template referenced at: http://documentation.coppermine-gallery.net/en/dev_plugin_steps.htm#steps
// followed steps in same doc to modify to accomodate additional variables.  Any deviations and my issues noted by comments.

// get sanitized POST parameters
if ($superCage->post->keyExists('submit')) {
    //Check if the form token is valid
    if(!checkFormToken()){
        cpg_die(ERROR, $lang_errors['invalid_form_token'], __FILE__, __LINE__);
    }

  // Define the sanitization patterns
  $sanitization_array = array(
      'plugin_gmc_test_adminmode' => array('type' => 'checkbox', 'min' => '0', 'max' => '1'),                       // checkbox - yes|no
// **GMC - my additional variables inserted here - using doc as reference.
// http://documentation.coppermine-gallery.net/en/dev_plugin_steps.htm#steps_config_defaults
      'plugin_gmc_test_menu_doc' => array('type' => 'checkbox', 'min' => '0', 'max' => '1'),                        // checkbox - yes|no
      'plugin_gmc_test_menu_minicms' => array('type' => 'checkbox', 'min' => '0', 'max' => '1'),                    // checkbox - yes|no
//      'plugin_gmc_test_checkbox' => array('type' => 'checkbox', 'min' => '0', 'max' => '1'),                        // checkbox - yes|no
//      'plugin_gmc_test_radio' => array('type' => 'checkbox', 'min' => '0', 'max' => '2'),                           // radio - 0|1|2
//      'plugin_gmc_test_dropdown' => array('type' => 'array', 'regex' => '/^[A-Za-z ]+$/', 'delimiter' => '|'),      // dropdown - built from *.ttf files loaded
//      'plugin_gmc_test_integer' => array('type' => 'int', 'min' => '6', 'max' => '24'),                             // integer - 6 -> 24
//      'plugin_gmc_test_text' => array('type' => 'raw', 'regex' => '/^[A-Za-z&@;.() ]+$/'),                          // text - A-Z a-z & @ ; . ( ) blank
  );
  $config_changes_counter = 0;
  foreach ($sanitization_array as $san_key => $san_value) {
      if (isset($CONFIG[$san_key]) == TRUE) { // only loop if config value is set --- start
          if ($san_value['type'] == 'checkbox') { // type is checkbox --- start
// **GMC - replace if/elseif commented below with next 4 lines... this validation used for BOTH checkbox and radio per doc and reviewing code...
// For checkbox, the code properly handles the case of 'unchecked' - where the variable isn't even present in the form
// BUT - for radio - if the value specified is between min and max - but is not min, and is not max... it wasn't allowed
// This change properly handles both Checkbox and Radio input.
              if ($superCage->post->getInt($san_key) <= $san_value['max'] && $superCage->post->getInt($san_key) >= $san_value['min'] && $superCage->post->getInt($san_key) != $CONFIG[$san_key]) {
                $CONFIG[$san_key] = $superCage->post->getInt($san_key);
                cpg_db_query("UPDATE {$CONFIG['TABLE_CONFIG']} SET value='{$CONFIG[$san_key]}' WHERE name='$san_key'");
                $config_changes_counter++;
//          if ($superCage->post->getInt($san_key) == $san_value['max'] && $CONFIG[$san_key] != $san_value['max']) {
//                $CONFIG[$san_key] = $san_value['max'];
//                cpg_db_query("UPDATE {$CONFIG['TABLE_CONFIG']} SET value='{$CONFIG[$san_key]}' WHERE name='$san_key'");
//                $config_changes_counter++;
//            } elseif($superCage->post->getInt($san_key) == $san_value['min'] && $CONFIG[$san_key] != $san_value['min']) {
//                $CONFIG[$san_key] = $san_value['min'];
//                cpg_db_query("UPDATE {$CONFIG['TABLE_CONFIG']} SET value='{$CONFIG[$san_key]}' WHERE name='$san_key'");
//                $config_changes_counter++;
// **GMC - end of modification (continue to validate 'unchecked' box - missing variable.)
            } elseif($superCage->post->keyExists($san_key) != TRUE && $CONFIG[$san_key] != '0') {
                $CONFIG[$san_key] = 0;
                cpg_db_query("UPDATE {$CONFIG['TABLE_CONFIG']} SET value='{$CONFIG[$san_key]}' WHERE name='$san_key'");
                $config_changes_counter++;
            }
          } // type is checkbox --- end
          if ($san_value['type'] == 'int') { // type is integer --- start
              if ($superCage->post->getInt($san_key) <= $san_value['max'] && $superCage->post->getInt($san_key) >= $san_value['min'] && $superCage->post->getInt($san_key) != $CONFIG[$san_key]) {
                  $CONFIG[$san_key] = $superCage->post->getInt($san_key);
                  cpg_db_query("UPDATE {$CONFIG['TABLE_CONFIG']} SET value='{$CONFIG[$san_key]}' WHERE name='$san_key'");
                  $config_changes_counter++;
              }
          } // type is integer --- end
          if ($san_value['type'] == 'raw') { // type is raw --- start
// **GMC following line incorrectly referenced array key 'regex_ok' instead of 'regex' - causing all input to FAIL validation... $san_value doesn't contain 'regex_ok' key
              if (isset($san_value['regex']) == TRUE && preg_match($san_value['regex'], $superCage->post->getRaw($san_key)) && $superCage->post->getRaw($san_key) != $CONFIG[$san_key]) {
                  $CONFIG[$san_key] = $superCage->post->getRaw($san_key);
                  if ($superCage->post->getRaw($san_key) == 'none') {
                    $CONFIG[$san_key] = '';
                  }
                  cpg_db_query("UPDATE {$CONFIG['TABLE_CONFIG']} SET value='{$CONFIG[$san_key]}' WHERE name='$san_key'");
                  $config_changes_counter++;
              }
          } // type is raw --- end
          if ($san_value['type'] == 'array') { // type is array --- start              
          $evaluate_value = $superCage->post->getRaw($san_key);
// **GMC following line incorrectly referenced array key 'regex_ok' instead of 'regex' - causing all input to BYPASS validation...
              if (is_array($evaluate_value) && isset($san_value['regex']) == TRUE && isset($san_value['delimiter']) == TRUE) {
                  $temp = '';
                  for ($i = 0; $i <= count($evaluate_value); $i++) {
// **GMC following line incorrectly referenced array key 'regex_ok' instead of 'regex' - code was bypassed until above change...
                      if (preg_match($san_value['regex'], $evaluate_value[$i])) {
                          $temp .= $evaluate_value[$i] . $san_value['delimiter'];
                      }
                  }
                  unset($evaluate_value);
                  $evaluate_value = rtrim($temp, $san_value['delimiter']);
                  unset($temp);
              }
              if ($evaluate_value != $CONFIG[$san_key]) {
                  $CONFIG[$san_key] = $evaluate_value;
                  cpg_db_query("UPDATE {$CONFIG['TABLE_CONFIG']} SET value='{$CONFIG[$san_key]}' WHERE name='$san_key'");
                  $config_changes_counter++;
              }
          } // type is array --- end
      } // only loop if config value is set --- end
  }
}


// display config page
// get language files
require "./plugins/gmc_test/lang/english.php";
if ($CONFIG['lang'] != 'english' && file_exists("./plugins/gmc_test/lang/{$CONFIG['lang']}.php")) {
    require "./plugins/gmc_test/lang/{$CONFIG['lang']}.php";
}
// Set the option output stuff 
if ($CONFIG['plugin_gmc_test_adminmode'] == '1') {
    $option_output['plugin_gmc_test_adminmode'] = 'checked="checked"';
} else { 
    $option_output['plugin_gmc_test_adminmode'] = '';
}

if ($CONFIG['plugin_gmc_test_menu_doc'] == '1') {
    $option_output['plugin_gmc_test_menu_doc'] = 'checked="checked"';
} else { 
    $option_output['plugin_gmc_test_menu_doc'] = '';
}

if ($CONFIG['plugin_gmc_test_menu_minicms'] == '1') {
    $option_output['plugin_gmc_test_menu_minicms'] = 'checked="checked"';
} else { 
    $option_output['plugin_gmc_test_menu_minicms'] = '';
}

/* CHECKBOX
if ($CONFIG['plugin_gmc_test_checkbox'] == '1') {
    $option_output['plugin_gmc_test_checkbox'] = 'checked="checked"';
} else { 
    $option_output['plugin_gmc_test_checkbox'] = '';
}
*/

/* RADIO
if ($CONFIG['plugin_gmc_test_radio'] == '0') {
    $option_output['plugin_gmc_test_radio'][0] = 'checked="checked"';
    $option_output['plugin_gmc_test_radio'][1] = '';
    $option_output['plugin_gmc_test_radio'][2] = '';
} elseif ($CONFIG['plugin_gmc_test_radio'] == '1') {
    $option_output['plugin_gmc_test_radio'][0] = '';
    $option_output['plugin_gmc_test_radio'][1] = 'checked="checked"';
    $option_output['plugin_gmc_test_radio'][2] = '';
} elseif ($CONFIG['plugin_gmc_test_radio'] == '2') {
    $option_output['plugin_gmc_test_radio'][0] = '';
    $option_output['plugin_gmc_test_radio'][1] = '';
    $option_output['plugin_gmc_test_radio'][2] = 'checked="checked"';
}
*/

/* DROP DOWN
if ($CONFIG['plugin_gmc_test_dropdown'] == 'option0') {
    $option_output['plugin_gmc_test_dropdown'][0] = 'SELECTED';
    $option_output['plugin_gmc_test_dropdown'][1] = '';
    $option_output['plugin_gmc_test_dropdown'][2] = '';
} elseif ($CONFIG['plugin_gmc_test_dropdown'] == 'option1') {
    $option_output['plugin_gmc_test_dropdown'][0] = '';
    $option_output['plugin_gmc_test_dropdown'][1] = 'SELECTED';
    $option_output['plugin_gmc_test_dropdown'][2] = '';
} elseif ($CONFIG['plugin_gmc_test_dropdown'] == 'option2') {
    $option_output['plugin_gmc_test_dropdown'][0] = '';
    $option_output['plugin_gmc_test_dropdown'][1] = '';
    $option_output['plugin_gmc_test_dropdown'][2] = 'SELECTED';
}
*/


pageheader(sprintf($lang_plugin_gmc_test['configure_x'], $lang_plugin_gmc_test['plugin_name']));
list($timestamp, $form_token) = getFormToken();
echo <<< EOT
<form action="index.php?file=gmc_test/admin" method="post" name="gmc_test_settings">
EOT;
starttable('100%', sprintf($lang_plugin_gmc_test['configure_x'], $lang_plugin_gmc_test['plugin_name']), 3, 'cpg_zebra');

if ($superCage->post->keyExists('submit')) {
    if ($config_changes_counter > 0) {
        echo <<< EOT
    <tr>
        <td class="tablef" colspan="2" >
EOT;
        msg_box('', $lang_plugin_gmc_test['update_success'], '', '', 'success');
    } else {
        msg_box('', $lang_plugin_gmc_test['no_changes'], '', '', 'validation');
    }
        echo <<< EOT
        </td>
    </tr>
EOT;
}

echo <<< EOT
    <!-- insert config option form code start -->
    <tr>
      <td>
        <label for="plugin_gmc_test_menu_doc" class="clickable_option">{$lang_plugin_gmc_test['menu_doc']}</label>
      </td>
      <td>
        <input type="checkbox" name="plugin_gmc_test_menu_doc" id="plugin_gmc_test_menu_doc" class="checkbox" value="1" {$option_output['plugin_gmc_test_menu_doc']} />
        <label for="plugin_gmc_test_menu_doc" class="clickable_option">{$lang_common['yes']}</label>
      </td>
    </tr>

    <tr>
      <td>
        <label for="plugin_gmc_test_menu_minicms" class="clickable_option">{$lang_plugin_gmc_test['menu_minicms']}</label>
      </td>
      <td>
        <input type="checkbox" name="plugin_gmc_test_menu_minicms" id="plugin_gmc_test_menu_minicms" class="checkbox" value="1" {$option_output['plugin_gmc_test_menu_minicms']} />
        <label for="plugin_gmc_test_menu_minicms" class="clickable_option">{$lang_common['yes']}</label>
      </td>
    </tr>
EOT;

// copy fields needed to be within ECHO above
/* CHECKBOX
    <tr>
      <td>
        <label for="plugin_gmc_test_checkbox" class="clickable_option">{$lang_plugin_gmc_test['checkbox']}</label>
      </td>
      <td>
        <input type="checkbox" name="plugin_gmc_test_checkbox" id="plugin_gmc_test_checkbox" class="checkbox" value="1" {$option_output['plugin_gmc_test_checkbox']} />
        <label for="plugin_gmc_test_checkbox" class="clickable_option">{$lang_common['yes']}</label>
      </td>
    </tr>
*/

/* RADIO
    <tr>
      <td style="vertical-align:top;">
        {$lang_plugin_gmc_test['radio']}
      </td>
      <td>
        <input type="radio" name="plugin_gmc_test_radio" id="plugin_gmc_test_radio_0" class="radio" value="0" {$option_output['plugin_gmc_test_radio'][0]} />
        <label for="plugin_gmc_test_mask_url_0" class="clickable_option">{$lang_plugin_gmc_test['option0']}</label><br />
        <input type="radio" name="plugin_gmc_test_radio" id="plugin_gmc_test_radio_1" class="radio" value="1" {$option_output['plugin_gmc_test_radio'][1]} />
        <label for="plugin_gmc_test_mask_url_1" class="clickable_option">{$lang_plugin_gmc_test['option1']}</label><br />
        <input type="radio" name="plugin_gmc_test_radio" id="plugin_gmc_test_radio_2" class="radio" value="2" {$option_output['plugin_gmc_test_radio'][2]} />
        <label for="plugin_gmc_test_mask_url_2" class="clickable_option">{$lang_plugin_gmc_test['option2']}</label><br />
      </td>
    </tr>
*/

/* DROPDOWN
    <tr>
      <td valign="top">
        {$lang_plugin_gmc_test['dropdown']}
      </td>
      <td>
        <select name="plugin_gmc_test_dropdown" id="plugin_gmc_test_dropdown" class="listbox">
          <option value="option0" {$option_output['plugin_gmc_test_dropdown'][0]}>agne</option>
          <option value="option1" {$option_output['plugin_gmc_test_dropdown'][1]}>font2</option>
          <option value="option2" {$option_output['plugin_gmc_test_dropdown'][2]}>font3</option>
        </select>
      </td>
    </tr>
*/

/* TEXTBOX
    <tr>
      <td valign="top">
        {$lang_plugin_gmc_test['text']}
      </td>
      <td>
        <input type="text" name="plugin_gmc_test_text" id="plugin_gmc_test_text" class="textinput" size="2" maxlength="2" value="{$CONFIG['plugin_gmc_test_text']}" {$option_output['plugin_gmc_test_text']} />
        {$lang_plugin_gmc_test['textdesc']}
      </td>
    </tr>
*/


echo <<< EOT
    <!-- insert config option form code end -->
    <tr>
        <td class="tablef" colspan="3">
            <input type="hidden" name="form_token" value="{$form_token}" />
            <input type="hidden" name="timestamp" value="{$timestamp}" />
            <button type="submit" class="button" name="submit" value="{$lang_plugin_gmc_test['submit']}">{$lang_plugin_gmc_test['submit']}</button>
        </td>
    </tr>
EOT;

endtable();
echo <<< EOT
</form>
EOT;

// insert additional test code here...

$gmc_test_var1 = 'Variable 1 found';
$gmc_test_var2 = 'Variable 2 found';
gmc_test_display_vars();

// end test code

pagefooter();
?>