<?php
/**************************************************
  Coppermine 1.5.x Plugin - gmc_test
**************************************************/

// Make sure that this file can't be accessed directly, but only from within the Coppermine user interface
if (!defined('IN_COPPERMINE')) {
    die('Not in Coppermine...');
}

include_once('functions.php');                                                  // include plugin subfunctions

// Define plugin actions here
$thisplugin->add_action('plugin_install','gmc_test_install');
$thisplugin->add_action('plugin_uninstall','gmc_test_uninstall');
$thisplugin->add_action('page_start','gmc_test_admin_button');                  // add admin button (per minicms)

// Define plugin filters here
$thisplugin->add_filter('admin_menu','gmc_test_config_button');                 // admin menu intercept to add button to menu (per doc)
// $thisplugin->add_filter('html_image','gmc_test_html_image');                    // html_image intercept
// $thisplugin->add_filter('html_image_reduced','gmc_test_html_image');            // html_image intercept
// $thisplugin->add_filter('fullsize_html','gmc_test_fullsize_html');              // fullsize_html intercept
// $thisplugin->add_filter('picture_url','gmc_test_picture_url');                  // picture_url intercept

// Define the plugin's functions here
function gmc_test_install() {
    global $CONFIG;
    // Add the config options for the plugin
    cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('plugin_gmc_test_menu_doc', '0')");
    cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('plugin_gmc_test_menu_minicms', '0')");
    return true;
}


function gmc_test_admin_button() {
//example from minicms_add_admin_button" href = 'index.php?file=minicms/cms_admin', $title = $lang_minicms['admin_title'], $target = '', $link = $lang_minicms['admin_title']);
    global $template_gallery_admin_menu;
    global $CONFIG;
    if ((GALLERY_ADMIN_MODE) && ($CONFIG['plugin_gmc_test_menu_minicms'] == 1)) {
      // get language files
      $gallery_merge_admin_button = TRUE;
      require "./plugins/gmc_test/lang/english.php";
      if ($CONFIG['lang'] != 'english' && file_exists("./plugins/gmc_test/lang/{$CONFIG['lang']}.php")) {
        require "./plugins/gmc_test/lang/{$CONFIG['lang']}.php";
      }

    $new_template=$template_gallery_admin_menu;
    $button=template_extract_block($new_template,'documentation');
    $params = array(
      '{DOCUMENTATION_HREF}' => 'index.php?file=gmc_test/admin&action=configure',
      '{DOCUMENTATION_TITLE}' => $lang_plugin_gmc_test['adminbutton2'],
      'target="cpg_documentation"' => '',
      '{DOCUMENTATION_LNK}' => $lang_plugin_gmc_test['adminbutton2'],
   );
   $new_button="<!-- BEGIN $link -->".template_eval($button,$params)."<!-- END $link -->\n";
   template_extract_block($template_gallery_admin_menu,'documentation',"<!-- BEGIN documentation -->" . $button . "<!-- END documentation -->\n" . $new_button);
  }
}


// This code based on CPG doc - but doesn't properly add button in all theme types - themes with dropdown menus have an issue
function gmc_test_config_button($admin_menu){
    global $CONFIG, $gmc_test_icon_array;
    if ($CONFIG['plugin_gmc_test_menu_doc'] == 1) {
      // get language files
      $gallery_merge_admin_button = TRUE;
      require "./plugins/gmc_test/lang/english.php";
      if ($CONFIG['lang'] != 'english' && file_exists("./plugins/gmc_test/lang/{$CONFIG['lang']}.php")) {
        require "./plugins/gmc_test/lang/{$CONFIG['lang']}.php";
      }
      $new_button =  "\n<!-- BEGIN GMC Test Admin -->";
      $new_button .= '  <div class="admin_menu admin_float"><a href="index.php?file=gmc_test/admin&action=configure"';
      $new_button .= ' title="' . $lang_plugin_gmc_test['adminbutton'] . '">';
      $new_button .= $gmc_test_icon_array['config_menu'] . $lang_plugin_gmc_test['adminbutton'] . '</a></div>';
      $new_button .=  "<!-- END GMC Test Admin -->\n";
      $look_for = '<!-- END documentation -->'; // This is where you determine the place in the admin menu
      $admin_menu = str_replace($look_for, $look_for . $new_button, $admin_menu);
    }
    return $admin_menu;
}


// function to modify pic_row
function gmc_test_picture_url($pic_row) {
    global $CONFIG;
    return $pic_row;
}

 
// function to modify pic_html
function gmc_test_html_image($pic_html) {
    global $CONFIG;
    return $pic_html;
}


// function to modify fullsize_html
function gmc_test_fullsize_html($fullsize_html) {
    global $CONFIG;
    return $fullsize_html;
}


function gmc_test_uninstall() {
    global $CONFIG, $lang_errors;
    $superCage = Inspekt::makeSuperCage();
    if (!checkFormToken()) {
        cpg_die(ERROR, $lang_errors['invalid_form_token'], __FILE__, __LINE__);
    }
    // Delete the plugin config records
    cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'plugin_gmc_test_menu_doc'");
    cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'plugin_gmc_test_menu_minicms'");

    return true;
}
?>